From 5d722838ea920b62b7a2b26bf88a2753191fe55b Mon Sep 17 00:00:00 2001
From: David Malcolm <dmalcolm@redhat.com>
Date: Wed, 12 Oct 2016 14:41:43 -0400
Subject: [PATCH 01/20] (committed) (v2) Tweaks to print_rtx_function

On Wed, 2016-10-12 at 19:31 +0200, Bernd Schmidt wrote:
> On 10/12/2016 07:48 PM, David Malcolm wrote:

[...snip...]

> > I think the only remaining item from our discussion above is what
> > to do
> > about the numbering of pseudos in the dumps (currently it just
> > prints the regno
> > unmodified).
> >
> > Other than that, is the resultant dump format good enough that I
> > can start
> > rewriting the RTL frontend parser, or are there other changes you'd
> > want?
>
> Give me a day or two to think it over, and for others to chime in.
> But I
> think this is reasonably close to what it should look like. Maybe
> empty
> edge flags don't need to be printed, and possibly there could be a
> more
> compact format for a large number edges like what you have for the
> switch?

[...snip...]

This patch implements:
* the renumbering of non-virtual pseudos, using
  LAST_VIRTUAL_REGISTER + 1 as a base, with a "%" sigil
* omitting the edge "(flags)" directive if there aren't any

Changed in v2:
* use of '%' sigil for non-virtual pseudos

gcc/ChangeLog:
	* print-rtl-function.c (print_edge): Omit "(flags)" when none are
	set.
	(print_rtx_function): Update example in comment for...
	* print-rtl.c (print_rtx_operand_code_r): In compact mode, print
	non-virtual pseudos with a '%' sigil followed by the regno, offset
	by (LAST_VIRTUAL_REGISTER + 1), so that the first non-virtual
	pseudo is dumped as "%0".
---
 gcc/print-rtl-function.c | 29 ++++++++++++++++++-----------
 gcc/print-rtl.c          |  8 ++++++++
 2 files changed, 26 insertions(+), 11 deletions(-)

diff --git a/gcc/print-rtl-function.c b/gcc/print-rtl-function.c
index 2abae84..f46304b 100644
--- a/gcc/print-rtl-function.c
+++ b/gcc/print-rtl-function.c
@@ -60,9 +60,11 @@ print_edge (FILE *outfile, edge e, bool from)
 
   /* Express edge flags as a string with " | " separator.
      e.g. (flags "FALLTHRU | DFS_BACK").  */
-  fprintf (outfile, " (flags \"");
-  bool seen_flag = false;
-#define DEF_EDGE_FLAG(NAME,IDX) \
+  if (e->flags)
+    {
+      fprintf (outfile, " (flags \"");
+      bool seen_flag = false;
+#define DEF_EDGE_FLAG(NAME,IDX)			\
   do {						\
     if (e->flags & EDGE_##NAME)			\
       {						\
@@ -75,7 +77,10 @@ print_edge (FILE *outfile, edge e, bool from)
 #include "cfg-flags.def"
 #undef DEF_EDGE_FLAG
 
-  fprintf (outfile, "\"))\n");
+      fprintf (outfile, "\")");
+    }
+
+  fprintf (outfile, ")\n");
 }
 
 /* If BB is non-NULL, print the start of a "(block)" directive for it
@@ -132,7 +137,9 @@ can_have_basic_block_p (const rtx_insn *insn)
    If COMPACT, then instructions are printed in a compact form:
    - INSN_UIDs are omitted, except for jumps and CODE_LABELs,
    - INSN_CODEs are omitted,
-   - register numbers are omitted for hard and virtual regs
+   - register numbers are omitted for hard and virtual regs, and
+     non-virtual pseudos are offset relative to the first such reg, and
+     printed with a '%' sigil e.g. "%0" for (LAST_VIRTUAL_REGISTER + 1),
    - insn names are prefixed with "c" (e.g. "cinsn", "cnote", etc)
 
    Example output (with COMPACT==true):
@@ -148,13 +155,13 @@ can_have_basic_block_p (const rtx_insn *insn)
 		       (reg:SI di [ i ])) "t.c":2
 		   (nil))
 	 (cnote NOTE_INSN_FUNCTION_BEG)
-	 (cinsn (set (reg:SI 89)
+	 (cinsn (set (reg:SI %2)
 		       (mem/c:SI (plus:DI (reg/f:DI virtual-stack-vars)
 			       (const_int -4)) [1 i+0 S4 A32])) "t.c":3
 		   (nil))
 	 (cinsn (parallel [
-			   (set (reg:SI 87 [ _2 ])
-			       (ashift:SI (reg:SI 89)
+			   (set (reg:SI %0 [ _2 ])
+			       (ashift:SI (reg:SI %2)
 				   (const_int 1)))
 			   (clobber (reg:CC flags))
 		       ]) "t.c":3
@@ -162,11 +169,11 @@ can_have_basic_block_p (const rtx_insn *insn)
 				   (const_int -4)) [1 i+0 S4 A32])
 			   (const_int 1))
 		       (nil)))
-	 (cinsn (set (reg:SI 88 [ <retval> ])
-		       (reg:SI 87 [ _2 ])) "t.c":3
+	 (cinsn (set (reg:SI %1 [ <retval> ])
+		       (reg:SI %0 [ _2 ])) "t.c":3
 		   (nil))
 	 (cinsn (set (reg/i:SI ax)
-		       (reg:SI 88 [ <retval> ])) "t.c":4
+		       (reg:SI %1 [ <retval> ])) "t.c":4
 		   (nil))
 	 (cinsn (use (reg/i:SI ax)) "t.c":4
 		   (nil))
diff --git a/gcc/print-rtl.c b/gcc/print-rtl.c
index f114cb4..46f3c4d 100644
--- a/gcc/print-rtl.c
+++ b/gcc/print-rtl.c
@@ -400,6 +400,14 @@ print_rtx_operand_code_r (const_rtx in_rtx)
 #endif
     if (flag_dump_unnumbered && is_insn)
       fputc ('#', outfile);
+    else if (flag_compact)
+      {
+	/* In compact mode, print pseudos with a '%' sigil following
+	   by the regno, offset by (LAST_VIRTUAL_REGISTER + 1), so that the
+	   first non-virtual pseudo is dumped as "%0".  */
+	gcc_assert (regno > LAST_VIRTUAL_REGISTER);
+	fprintf (outfile, " %%%d", regno - (LAST_VIRTUAL_REGISTER + 1));
+      }
     else
       fprintf (outfile, " %d", regno);
 
-- 
1.8.5.3

